/** 
	 * FullMouseMode.java
	 * Autor: Alberto Población Navarro
	 * Añadido a:
	 		* Archivo original: http://code.google.com/p/android-vnc-viewer/source/browse/branches/antlersoft/androidVNC/src/android/androidVNC/VncCanvasActivity.java
	 		* Release: 39
	 * Librerias utilizadas: open_intents-lib.jar
	 * Referencia: http://code.google.com/p/openintents/wiki/SensorSimulator
	 */
package android.androidVNC;

import org.openintents.hardware.SensorManagerSimulator;
import org.openintents.provider.Hardware;
import android.content.Intent;
import android.hardware.SensorListener;
import android.hardware.SensorManager;


/**
 * Clase que se encarga de conectar con un simulador que emula movimientos del teléfono.
 * Si hay movimientos de mas de 10 grados se mueve el escritorio en esa direccion
 * @author Alberto Población Navarro
 *
 */
public class Sensores{
		
	private SensorManager sensors;
	public VncCanvasActivity vncCanvasActivity;
	public VncCanvas vncCanvas;
	
	
		Sensores(VncCanvasActivity vnccanvasactivity, VncCanvas vnccanvas){
			vncCanvas = vnccanvas;
			vncCanvasActivity = vnccanvasactivity;
			//vncCanvas.ctrlAltDel();
			
			//Con movil real
	        // sensors=(SensorManager)getSystemService(Context.SENSOR_SERVICE);
	      //<Con simulador+emulador>
	        // Before calling any of the Simulator data, 
	        // the Content resolver has to be set !! 
	        Hardware.mContentResolver = vncCanvasActivity.getContentResolver(); 
	        // Link sensor manager to OpenIntents Sensor simulator 
	        sensors = (SensorManager) new SensorManagerSimulator((SensorManager)vncCanvasActivity.getSystemService(vncCanvasActivity.SENSOR_SERVICE)); 
	        
	        Intent intent = new Intent(Intent.ACTION_VIEW, 	Hardware.Preferences.CONTENT_URI); 
	        vncCanvasActivity.startActivity(intent);
	        
	        //sensors.unregisterListener(R.layout.main); 
	 
	        SensorManagerSimulator.connectSimulator(); 
	      //</Con simulador+emulador>
	       
	        SensorListener sensorlistener = new SensorListener(){

				@Override
				public void onAccuracyChanged(int sensor, int accuracy) {
					// TODO Auto-generated method stub
					
				}
				
				final int EJEX=0; //Posicion del eje x en el vector
				final int EJEY=1; //Posicion del eje y en el vector
				final int EJEZ=2; //Posicion del eje z en el vector
				final int MOVER=20; //Cantidad de pixeles que se desplaza el escritorio
				
				boolean valores_inciales=true; //Flag para saber si es la primera vez que se ejecuta la funcion
				float ejex; //Valor inicial eje x
				float ejey; //Valor inicial eje y
				float ejez; //Valor inicial eje z
				
				@Override
				public void onSensorChanged(int sensor, float[] values) {
					int scrollX=0;
					int scrollY=0;
					
					if(valores_inciales)
					{
						ejex=values[EJEX];
						ejey=values[EJEY];
						ejez=values[EJEZ];
						
						valores_inciales = false;
					}
					
					if(sensor==SensorManager.SENSOR_ORIENTATION){
						
						// Obtenemos uns valores iniciales y si hay una variacion de 10º en la horientazion movemos el escritorio							
						if(values[EJEX] > (ejex+10)) //Extremo izquierdo hacia atras	
							scrollX -= MOVER;
						else if (values[EJEX]+10 < ejex) //Extrmos derecho hacia atras 
							scrollX +=MOVER;
						//Y -90 usamos el marge de 20 
						if(values[EJEZ] > (ejez+10))	//Pantalla hacia arriba
							scrollY -= MOVER;
						else if (values[EJEZ]+10 < ejez) //Pantalla hacia abajo 
							scrollY +=MOVER;
						
										
										
						vncCanvasActivity.absoluteXPosition += scrollX;
						vncCanvasActivity.absoluteYPosition += scrollY;
						//Limites Eje X
						if(vncCanvasActivity.absoluteXPosition < 0){
							scrollX=0;
							vncCanvasActivity.absoluteXPosition=0;
						}
						if(vncCanvasActivity.absoluteXPosition + vncCanvas.getWidth()> vncCanvas.getImageWidth()){
							scrollX=0;
							vncCanvasActivity.absoluteXPosition-=MOVER;
						}
						//Limites Eje Y
						if(vncCanvasActivity.absoluteYPosition < 0){
							scrollY=0;
							vncCanvasActivity.absoluteYPosition=0;
						}
						if(vncCanvasActivity.absoluteYPosition + vncCanvas.getHeight() > vncCanvas.getImageHeight()){
							scrollY=0;
							vncCanvasActivity.absoluteYPosition-=MOVER;
						}
						
						
						vncCanvas.scrollBy(scrollX,scrollY);
			
						
						
					}
					
				}
	        };
	        
	        sensors.registerListener(sensorlistener, SensorManager.SENSOR_ORIENTATION);
	        //En caso de necesitar los demas sensores
	        /*sensors.registerListener(sensorlistener, SensorManager.SENSOR_ACCELEROMETER);
	        sensors.registerListener(sensorlistener, SensorManager.SENSOR_MAGNETIC_FIELD);*/
	    
	 }
			
			
}
	
	
	

